from matrix import *


def visit(v,l,path, mark, adj, counter,maxPathDots):
    if(l<maxPathDots):
        for i in adj[v]:
            if(mark[i]==0):
                markCopy = mark[:]
                markCopy[i] = 1
                pathCopy = path[:]
                pathCopy.append(i)
                visit(i,l+1,pathCopy,mark, adj, counter, maxPathDots)
    else:
        #print(path)
        counter[0]+=1
        
        
        
# counts the number of paths starting with startVertex
# the square consists of n dots
def fun(startVertex,n, maxPathDots):
    path=[startVertex]

    mark = []
    for i in range(0,n*n):
        mark.append(0)
    
    mark[startVertex]=1
    counter = [0]

##    adj = [
##    [1,3,4], # node 0
##    [0,2,3,4,5], # node 1
##    [1,4,5], # node 2
##    [0,1,4,7,6], # node 3
##    [0,1,2,3,5,6,7,8], # node 4
##    [2,1,4,7,8], # node 5
##    [3,4,7], # node 6
##    [6,3,4,5,8], # node 7
##    [7,4,5] # node 8
##        ]

    g = GraphFromMatrix(n)
    adj = g.getAdjList()

    
    
    
    visit(startVertex,1,path, mark, adj, counter, maxPathDots)
    # print("number of paths starting with dot",startVertex, "is:  ", counter[0])
    return counter[0]


# THIS IS FOR THE USER:
# Run this program in the Python-Shell (e.g. by pressing F5 in idle)
# sums up the total number of paths consisting of 'maxPathDots' dots
def superFun(p,n):
    maxPathDots = p
    total = 0
    for i in range(0,n*n):
        total+=fun(i,n,maxPathDots)

    return total


def postOnPhysicsforums():
    print("The square looks like this: ")
    print("0 1 2")
    print("3 4 5")
    print("6 7 8")
    print()
    
    for i in range(1,10):
        print("path with", i, "dots   =>   ", superFun(i,3), "   combinations")

    print("\nNote: I counted paths such as (0 1 4) and (4 1 0) as two different paths")
    print("If you don't differ between those two you have only half the combinations, see below:")
    print()

    i=1
    print("path with", i, "dots   =>   ", superFun(i,3), "   combinations")
    for i in range(2,10):
        print("path with", i, "dots   =>   ", superFun(i,3)//2, "   combinations")
    

if __name__ == '__main__':
    postOnPhysicsforums()


