# creates a matrix in order to enumerate the nodes

class Matrix:
        def __init__(self, n):
                self.matrix = []
                self.n = n
                for i in range(0,n):
                        self.matrix.append([])

                
                for i in range(0,n):
                        for j in range(0,n):
                                self.matrix[i].append(0)

                counter = 0
                for j in range(0,n):
                        for i in range(0,n):
                                self.matrix[j][i] = counter
                                counter+=1

        def getMatrix(self):
                return self.matrix

        def getEntry(self,x,y):
                return self.matrix[x][y]

        def printMatrix(self):
                for i in range(0,n):
                        print(self.matrix[i])

        def getNeighborhood(self,i,j):
                entry = self.getEntry(i,j)
                neighList = []

                x = i-1
                y = j-1
                if(x in range(0,self.n) and y in range(0,self.n)):
                        neighList.append(self.getEntry(x,y))

                x = i
                y = j-1
                if(x in range(0,self.n) and y in range(0,self.n)):
                        neighList.append(self.getEntry(x,y))

                x = i+1
                y = j-1
                if(x in range(0,self.n) and y in range(0,self.n)):
                        neighList.append(self.getEntry(x,y))

                x = i-1
                y = j
                if(x in range(0,self.n) and y in range(0,self.n)):
                        neighList.append(self.getEntry(x,y))

                x = i+1
                y = j
                if(x in range(0,self.n) and y in range(0,self.n)):
                        neighList.append(self.getEntry(x,y))

                x = i-1
                y = j+1
                if(x in range(0,self.n) and y in range(0,self.n)):
                        neighList.append(self.getEntry(x,y))

                x = i
                y = j+1
                if(x in range(0,self.n) and y in range(0,self.n)):
                        neighList.append(self.getEntry(x,y))

                x = i+1
                y = j+1
                if(x in range(0,self.n) and y in range(0,self.n)):
                        neighList.append(self.getEntry(x,y))
                
                	
                return (neighList)
                
                

# takes a matrix and builds the adjacency list

class GraphFromMatrix:
        def __init__(self,n):
                self.n = n
                m = Matrix(n)
                self.adjList = []   # don't forget to initialize as empty list
                for i in range(0,n*n):
                        self.adjList.append([])

                for i in range(0,n):
                        for j in range(0,n):
                                matrixEntry = m.getEntry(i,j)
                                self.adjList[matrixEntry] = m.getNeighborhood(i,j)
                                
                                
        def printAdjList(self):
                for i in range(0,self.n*self.n):
                        print("node ", i, ": ", self.adjList[i])

        def getAdjList(self):
                return self.adjList
                        
                                
                                
                                
                                
                                
                                
                                
                        
                
